<?php

//ini_set('memory_limit','1024M');

$file_names_file_name = "tmbg_lyrics.txt";
$fh = fopen($file_names_file_name,"r") or die("Couldn't open ".$file_names_file_name."!");
$word_counts = array();
$total_words = 0;
$word_song_counts = array();
$total_songs = 0;
$seen_songs = array();
while (!feof($fh)) {
	$line = explode("\t",trim(fgets($fh)));
	$album_year = $line[0];
	$album_name = $line[1];
	$album_tracks = $line[2];
	for ($i=0; $i<=$album_tracks; $i++) {
		$track_filename = $album_name."/".$i.".txt";
		if (file_exists($track_filename)) {
			$this_song_words = array();
			$song = file_get_contents($track_filename) or die("Couldn't open track #$i from $album_name\n");
			$song_lines = explode("\n",$song,2);
			$song_title = $song_lines[0];
			if (!in_array($song_title,$seen_songs)) {
				array_push($seen_songs,$song_title);
				$song = flattenwhitespace($song);
				$song_words = explode(" ",$song);
				foreach ($song_words as $word) {
					$word = justword($word);
					if (isset($word_counts[$word]))
						$word_counts[$word]++;
					else 
						$word_counts[$word] = 1;
					if (!in_array($word,$this_song_words)) {
						if (isset($word_song_counts[$word]))
							$word_song_counts[$word]++;
						else 
							$word_song_counts[$word] = 1;
						array_push($this_song_words,$word);
					}
					$total_words++;
				}
				$total_songs++;
			}
		}
	}
	echo "Processed $album_name.\n";
}
fclose($fh);
arsort($word_song_counts);

/*
$corpus_size = 450000000;
$freq_filename = "word_frequencies.txt";
$freq_file = fopen($freq_filename,"r");
fgetcsv($freq_file,0,"\t");
 */
$corpus_size = 0;
$totals_file = fopen("Google_data/googlebooks-eng-1M-totalcounts-20090715.txt","r") or die("Can't open word totals file!\n");
fgetcsv($totals_file,0,"\t");
while (!feof($totals_file)) {
	$line = fgetcsv($totals_file,0,"\t");
	if (intval($line[0]) >= 1982) {
		$corpus_size += intval($line[1]);
	}
}
$corpus_freqs = array();
$google_files_rootname = "Google_data/googlebooks-eng-1M-1gram-20090715-";
for ($i=0; $i<10; $i++) {
	$this_filename = $google_files_rootname.$i.".csv";
	if (file_exists($this_filename)) {
		echo "Consulting $this_filename...\n";
		$freq_file = fopen($this_filename,"r");
		$j = 0;
		while (!feof($freq_file)) {
			if ($i == 7 && $j == 100187) {
				fgets($freq_file);
			} else {
				$line = fgetcsv($freq_file,1000,"\t");
				$word = trim(strtolower($line[0]));
				if (isset($word_counts[$word]) && intval($line[1]) >= 1982) {
					if (!isset($corpus_freqs[$word]))
						$corpus_freqs[$word] = intval($line[2]) / $corpus_size;
					else 
						$corpus_freqs[$word] += intval($line[2]) / $corpus_size;
				}
				//echo "\$j = $j \t";
			}
			$j++;
		}
	}
}

$output = "word,songCount,fracSongs,absCount,fracWords,relCorpus,totalSongs,$total_songs,totalWords,$total_words,\n";
$word_freqs = array();
foreach ($word_song_counts as $word => $count) {
	$fraction_counts = $word_counts[$word] / $total_words;
	$word_freqs[$word] = $fraction_counts;
	if (isset($corpus_freqs[$word]))
		$compare_corpus = $fraction_counts / $corpus_freqs[$word];
	else 
		$compare_corpus = 0;
	$fraction_songs = $count / $total_songs;
	$output .= "\"".$word."\",".$count.",".$fraction_songs.",".$word_counts[$word].",".$fraction_counts.",".$compare_corpus."\n";
}
$output_file = fopen("output.csv","w") or die("Couldn't open output file!");
fwrite($output_file,$output);
fclose($output_file);
echo "Output written to output.csv\n";


function justword($string) {
	$string = trim($string);
	$string = trim($string,".,-?!;:\'\"()—[]");
	$string = strtolower($string);
	return $string;
}

function flattenwhitespace($string) {
	$string = preg_replace("!\s+!"," ",$string);
	return $string;
}
?>